/* (c)migaco 	ecam@aon.at */

#include <stdint.h> // neu fuer standard integer Typen
#include <avr/io.h> // ios des Controllers
#include <avr/pgmspace.h> // routienen um aufs Flash zu schreiben usw.

//#include <stdio.h>

#include <stdlib.h> // fuer dtostrf()
#include <string.h> // fuer strcat()

#include "menue.h"
#include "lcd.h"

// Anzahl der Menue Eintraege im HauptMenue
#define MENUESIZE 7

// Daten Positon neben den Strings
#define DATAPOS 10

// Display Groesse
#define XLCD 20
#define YLCD 4

// Anz definiert wieviele Eintrge auf ein Mall angezeigt werden, achtung
// muss mindestens 1 sein und darf auch nicht groesser wie YLCD sien!
// wenn es nicht gleich wie YLCD gesetzt wird dann muessen die Daten 
// fuer die leeren Zeilen in der Benutzerdefinierten Funktion ausgegeben
// werden !!

#define ANZ 4 


//Benutzerdefiniertes Menue
typedef struct menue{
	char *text;
	int8_t previous; //menue vorher
	int8_t next; //naechstes menue
	char * (*fp) (void);
	//menueObject *sub; ??
	struct menue *sub;

}menueObject;



//Benutzerdefinierter Sub Menues
menueObject mySUBMenue0[]PROGMEM = {

    {"SUB TEST 0: ", 2, 1 ,NULL,NULL}, //0
	{"SUB TEST 1: ", 0 ,2 ,NULL,NULL}, //1
	{"SUB TEST 2: ", 1 ,0 ,NULL,NULL} //2
};

menueObject mySUBMenue1[]PROGMEM = {

    {"SUB  0: ", 2, 1 ,NULL,NULL}, //0
	{"SUB  1: ", 0 ,2 ,NULL,NULL}, //1
	{"SUB  2: ", 1 ,0 ,NULL,NULL} //2

};

//Hier muss die Laenge der einzelnen Submenues angegeben 
//werden ==> ich weis nicht wie man die Laenge von dem 
//jeweiligen SubMenue sonst herrausbekommt!
int sublength[]={3,3,0,0,0};


//Benutzerdefinierter HauptMenue Eintrag
menueObject myMenue[]PROGMEM = {
    
    {"Spannung: ", 6 ,1 ,function2,&mySUBMenue0[0]}, //0
	{"TEXT   2: ", 0 ,2 ,NULL,mySUBMenue1}, //1
	{"TEXT   3: ", 1 ,3 ,NULL,NULL}, //2
	{"TEXT   4: ", 2 ,4 ,NULL,NULL}, //3
	{"TEXT   5: ", 3 ,5 ,NULL,NULL}, //4
	{"TEXT   6: ", 4 ,6 ,NULL,NULL}, //5
	{"TEXT   7: ", 5 ,0 ,NULL,NULL} //6

};

//aktuelle Cursor Position;
int8_t position;

//Daten fr das Menue ==> zum Beispiel Messdaten vom main.c
uint16_t result;
int16_t spannung;


// Anzeigen des Menues (eigentlich die Hauptseite)
void menue_show(void){

	int8_t i;
	PGM_P text;
	extern int8_t position;
	extern menueObject myMenue[];
	
	//Funktionspointer auf die Menuefunktions des jeweiligen Eintrags
	//Funktion bekommt nicht und gibt eine String mit den Daten zurck.
	//Angezeigt werden diese auf der Position ==> DATAPOS 
	char* (*myFunc)(void);
	
	i = 0;
	position = 0;
	
   	lcd_clrscr();	
	lcd_gotoxy(0,0);
	lcd_command(LCD_DISP_ON);

	for(i=0; i<ANZ;i++){
		text =  (PGM_P) pgm_read_word(&myMenue[i].text);
		lcd_puts(text);

	    myFunc = (PGM_VOID_P) pgm_read_word(&myMenue[i].fp);
		
		if(myFunc != NULL){
			lcd_gotoxy(DATAPOS,i);
			lcd_puts("      ");
			lcd_gotoxy(DATAPOS,i);
			lcd_puts(myFunc());
			//lcd_puts(myFunc(),12,i);
		}else{
			//sonst alter Wert loeschen!!
			lcd_gotoxy(DATAPOS,i);
			lcd_puts("      ");
		}
		lcd_puts("\n");	
	}
}

void menue_update(void){

	int8_t i;
	PGM_P text;
	int8_t temp;

	extern int8_t position;
	extern menueObject myMenue[];

	char* (*myFunc)(void);   	


   	lcd_clrscr();	
	lcd_gotoxy(0,0);

    lcd_command(LCD_DISP_ON_BLINK);

	temp = position;

	for(i=0; i<ANZ;i++){
		
		if(temp > (MENUESIZE-1))
			temp = 0;
		
		text =  (PGM_P) pgm_read_word(&myMenue[temp].text);
		lcd_puts(text);

	    myFunc = (PGM_VOID_P) pgm_read_word(&myMenue[temp].fp);
		
		if(myFunc != NULL){
			lcd_gotoxy(DATAPOS,i);
			lcd_puts("      ");
			lcd_gotoxy(DATAPOS,i);
			lcd_puts(myFunc());
			//lcd_puts(myFunc(),12,i);
		}else{
			//sonst alter Wert loeschen!!
			lcd_gotoxy(DATAPOS,i);
			lcd_puts("      ");
		}
		lcd_puts("\n");

		temp = temp + 1;	
	}
}


//scroll up => 0 und down => 1 uebergeben!!

void menue_scroll(uint8_t up0down1){
	
	int8_t i;
	int8_t temp;
	extern int8_t position;
	//int16_t (*myFunc)(void);
	char* (*myFunc)(void);

	extern menueObject myMenue[];

	PGM_P text;
	
	if(up0down1){
		position = pgm_read_byte(&myMenue[position].next);
	}else position = pgm_read_byte(&myMenue[position].previous);

	temp = position;
 
	//lcd_puts_int(position,0,10);

	//zugefuegt!!
	lcd_clrscr();


	lcd_gotoxy(0,0);
	lcd_command(LCD_DISP_ON_BLINK);

	for(i=0; i<ANZ;i++){
		if(temp > (MENUESIZE-1))
			temp = 0;
		  
		text = (PGM_P) pgm_read_word(&myMenue[temp].text);
		lcd_puts(text);
		
		myFunc = (PGM_VOID_P) pgm_read_word(&myMenue[temp].fp);
		
		if(myFunc != NULL){

			lcd_gotoxy(DATAPOS,i);
			lcd_puts("      ");
			lcd_gotoxy(DATAPOS,i);
			lcd_puts(myFunc());
			//lcd_puts(myFunc(),12,i);

		}else{
			//sonst alter Wert loeschen!!
			lcd_gotoxy(DATAPOS,i);
			lcd_puts("      ");
		}

		
		lcd_puts("\n");									 
	
	    temp = temp + 1;	
	}
}

void subMenue_Enter(void){

	int8_t i;
	int8_t temp0;
	int8_t temp1;
	PGM_P text;
	extern int8_t position;
	menueObject *mySub;	
	i = 0;	
	//Aktuelle position vom Hauptmenue Merken!!
	temp0 = position;
 	temp1 = 0;

    //SubMenue lesen und Schauen obe auch eines vorhanden ist!!
	mySub = (menueObject*)pgm_read_word(&myMenue[temp0].sub);
	
	if(mySub != NULL){
		
		lcd_clrscr();	
		lcd_gotoxy(0,0);

		//mySub = (menueObject*)pgm_read_byte(pgm_read_byte(&myMenue[0].sub));
	
		for(i=0; i<sublength[temp0];i++){
			/*if(temp1 > (3 -1)) //3 ist die SubMenue groesse!!
				temp1 = 0; */
	   		
	   		text = (PGM_P) pgm_read_word(&mySub[temp1].text);
			lcd_puts(text);
			lcd_puts("\n");
	   
			temp1 = temp1+1;
		}

  	}else 
  		menue_update();

} 



//Hier werden die Benutzerdefinierten Funktionen Ausgprogrammiert!!


char* function2(void){

	char tempBuf[15];
	float temp = 0;
	extern int16_t spannung;
	
	temp = spannung *(5./1024);

	dtostrf(temp, 5, 2, tempBuf ) ; 
	  
	return strcat(tempBuf,"V");
	
}	   
